# How to contribute

If you'd like to help us improve and extend BuckleScript, then we welcome your
contributions!

Below you will find some basic steps required to be able to contribute to the project. If
you have any questions about this process or any other aspect of contributing to a Bloomberg open
source project, feel free to send an email to open-tech@bloomberg.net and we'll get your questions
answered as quickly as we can.


## Contribution Licensing

Since BuckleScript is distributed under the terms of the [LGPL Version 3](LICENSE), contributions that you make
are licensed under the same terms. In order for us to be able to accept your contributions,
we will need explicit confirmation from you that you are able and willing to provide them under
these terms, and the mechanism we use to do this is called a Developer's Certificate of Origin
[DCO](DCO.md).  This is very similar to the process used by the Linux(R) kernel, Samba, and many
other major open source projects.

To participate under these terms, all that you must do is include a line like the following as the
last line of the commit message for each commit in your contribution:

    Signed-Off-By: Random J. Developer <random@developer.example.org>

You must use your real name (sorry, no pseudonyms, and no anonymous contributions).
